diff --git a/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/ITVEInteraction.cs b/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/ITVEInteraction.cs
index 741fc37..004be72 100644
--- a/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/ITVEInteraction.cs
+++ b/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/ITVEInteraction.cs
@@ -52,6 +52,8 @@ namespace TV4Home.Server.TVEInteractionLibrary.Interfaces
         [OperationContract]
         WebChannelGroup GetGroupById(int groupId);
         [OperationContract]
+        void DeleteSchedule(int scheduleId);
+        [OperationContract]
         void CancelSchedule(int programId);
         [OperationContract]
         List<WebCard> GetCards();
diff --git a/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/WebActiveCard.cs b/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/WebActiveCard.cs
index 5af1a4f..a8a192d 100644
--- a/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/WebActiveCard.cs
+++ b/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/WebActiveCard.cs
@@ -9,7 +9,9 @@ namespace TV4Home.Server.TVEInteractionLibrary.Interfaces
     {
         #region Properties
         public string CardName { get; set; }
-        public WebChannel Channel { get; set; }
+        public int IdCard { get; set; }
+        public int IdChannel { get; set; }
+        public string UserName { get; set; }
         public bool IsTimeShifting { get; set; }
         public bool IsRecording { get; set; }
         #endregion
diff --git a/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/WebActiveUser.cs b/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/WebActiveUser.cs
index 1c1fdd4..2117984 100644
--- a/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/WebActiveUser.cs
+++ b/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary.Interfaces/WebActiveUser.cs
@@ -9,7 +9,8 @@ namespace TV4Home.Server.TVEInteractionLibrary.Interfaces
     {
         #region Properties
         public string User { get; set; }
-        public WebChannel Channel { get; set; }
+        public int IdCard { get; set; }
+        public int IdChannel { get; set; }
         #endregion
     }
 }
diff --git a/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary/TVEInteraction.cs b/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary/TVEInteraction.cs
index 41195de..05b7ee5 100644
--- a/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary/TVEInteraction.cs
+++ b/TV4Home/Server/TV4Home.Server.TVEInteractionLibrary/TVEInteraction.cs
@@ -242,6 +242,13 @@ namespace TV4Home.Server.TVEInteractionLibrary
             return ChannelGroup.Retrieve(groupId).ToWebChannelGroup();
         }
 
+        public void DeleteSchedule(int scheduleId) 
+        {
+            Schedule schedule = Schedule.Retrieve(scheduleId);
+            schedule.Remove();
+            _tvControl.OnNewSchedule();
+        }
+
         public void CancelSchedule(int programId)
         {
             Program program = Program.Retrieve(programId);
@@ -273,7 +280,9 @@ namespace TV4Home.Server.TVEInteractionLibrary
             return GetTimeshiftingOrRecordingVirtualCards().Select(tvCard => new WebActiveCard()
                                                                                  {
                                                                                      CardName = tvCard.Name,
-                                                                                     Channel = Channel.Retrieve(tvCard.IdChannel).ToWebChannel(),
+                                                                                     IdCard = tvCard.Id,
+                                                                                     IdChannel = tvCard.IdChannel,
+                                                                                     UserName = tvCard.User.Name,
                                                                                      IsTimeShifting = tvCard.IsTimeShifting,
                                                                                      IsRecording = tvCard.IsRecording,
                                                                                  }).ToList();
@@ -289,7 +298,8 @@ namespace TV4Home.Server.TVEInteractionLibrary
             return GetTimeshiftingOrRecordingVirtualCards().Select(tvCard => new WebActiveUser()
                                                                                  {
                                                                                      User = tvCard.User.Name,
-                                                                                     Channel = Channel.Retrieve(tvCard.IdChannel).ToWebChannel()
+                                                                                     IdCard = tvCard.Id,
+                                                                                     IdChannel = tvCard.IdChannel
                                                                                  }).ToList();
         }
 